#include "nakayama.h"

using namespace nn::red::nakayama;

class BackupMemoryTest : public CardTestProgram
{
  virtual void Execute()
  {
    Page page;

    Label title;
    title.X = 20;
    title.Y = 10;
    title.Text = "Backup Memory Test";
    page.Add(title);

    Label date;
    date.X = 250;
    date.Y = 10;
    date.Text = __DATE__;
    page.Add(date);

    ValueSelector menu;
    menu.X = 30;
    menu.Y = 40;
    page.Add(menu);

    SelectableValue<int> address;
    address.Add( 0 );
    address.Add( 1 );
    address.Add( 2 );
    menu.Register("Address", address);

    SelectableValue< NamedValue<int> > loop;
    loop.Add(*(new NamedValue<int>("Once", 0)));
    loop.Add(*(new NamedValue<int>("Repeat", 1)));
    menu.Register("Loop", loop);

    while(1)
    {
      page.Show(Display::GetInstance(Display::Upper));

      if(menu.Selected)
      {
        menu.Selected = false;
      }

      if(menu.Canceled)
      {
        menu.Canceled = false;
        break;
      }
    }
  };
};
