#include "nakayama.h"
#include "FunctionTest.cpp"
#include "CommandTest.cpp"
#include "ReliabilityTestForRom.cpp"
#include "ReliabilityTestForRWMemory.cpp"
#include "BackupMemoryTest.cpp"

using namespace nn::red::nakayama;

class CtrCardTest: public CardTestProgram
{
public:
  virtual void Execute()
  {
    Page page;

    Label title;
    title.X = 20;
    title.Y = 10;
    title.Text = "CTR Card Test";
    page.Add(title);

    Label date;
    date.X = 250;
    date.Y = 10;
    date.Text = __DATE__;
    page.Add(date);

    Selector<Program> menu;
    menu.X = 30;
    menu.Y = 40;
    page.Add(menu);

    menu.Register("Function Test", *(new FunctionTest()));
    menu.Register("Command Test", *(new CommandTest()));
    menu.Register("Reliability Test for ROM",*(new ReliabilityTestForRom()));
    menu.Register("Reliability Test for Writable Memory",*(new ReliabilityTestForRWMemory()));
    menu.Register("Back Up Memory Test", *(new BackupMemoryTest()));

    while (1)
	{
      page.Show(Display::GetInstance(Display::Upper));

      if (menu.Selected)
      {
        menu.GetSelectedItem()->Execute();
        menu.Selected = false;
      }
    }
  };
};

